Attribute VB_Name = "Module1"
'RAS Image Viewer for Visual Basic 5.0 and up
'
'Copyright 2003 by Dmitry Brant, All Rights Reserved.

'Version 1.0, Last modified 08-27-2002
'
'me@dmitrybrant.com
'
'http://www.dmitrybrant.com


'This program fully supports the Sun Rasterfile specification.

'Feel free to make improvements or optimizations to the program.
'If you do, please tell me or show me what you have done.

'This program is FREEWARE. Use freely, but give me credit
'where credit is due. (this program is NOT in the
'public domain). If you will use this source code in
'your software, the copyright notice stated above
'must be included in your source code and/or in the
'Help/About box of your program.

'The SOURCE CODE of this program, or portions of it, may not
'be redistributed, either by itself or in a compilation
'package, without express authorization from the author.

'ALL PRODUCT NAMES MENTIONED IN THIS SOFTWARE ARE TRADEMARKS
'OR REGISTERED TRADEMARKS OF THEIR RESPECTIVE OWNERS.

'THIS SOFTWARE IS DISTRIBUTED "AS IS". THE SOFTWARE IS
'DISTRIBUTED WITH NO WARRANTY, EIHER EXPRESSED
'OR IMPLIED, INCLUDING, BY WAY OF EXAMPLE THE IMPLIED
'WARRANTIES OF MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
'PURPOSE. THE AUTHOR WILL NOT BE LIABLE FOR DATA LOSS, DAMAGES,
'LOSS OF PROFITS OR ANY OTHER KIND OF LOSS RESULTING FROM THE
'USE OR MISUSE OF THIS SOFTWARE.

Option Explicit
DefInt A-Z

Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Sub DoRAS(FName As String, FObject As Object)
    Dim str1 As String, theHdc As Long, odd As Byte
    Dim FWidth As Long, FHeight As Long
    Dim Bpp As Integer, Length As Long
    Dim Typ As Long, dx As Integer, dy As Integer
    Dim MapType As Integer, MapLen As Long
    Dim i As Integer, j As Integer, k As Integer, l As Integer
    
    On Error GoTo ErrorTrap0
    
    Open FName For Binary As #1
    
    str1 = "    "
    theHdc = FObject.hdc
    
    Get #1, , str1
    
    If str1 <> "Yj" Then
        Close #1
        MsgBox "This is not a valid RAS Image.", vbCritical, "Error"
        Exit Sub
    End If
    
    FWidth = GetDword
    FHeight = GetDword
    Bpp = GetDword
    Length = GetDword
    Typ = GetDword
    MapType = GetDword
    MapLen = GetDword
    FObject.Width = FWidth
    FObject.Height = FHeight
    
    If FWidth Mod 2 = 1 And Bpp = 8 Then FWidth = FWidth + 1: odd = 2 Else odd = 1
    
    If Bpp <> 8 And Bpp <> 24 And Bpp <> 1 Then
        MsgBox "We only support 1-Bit, 8-bit, and 24-bit RAS Images.", vbCritical, "Error"
        Close #1
        Exit Sub
    End If
    
    If MapType > 0 Then
        ReDim Palette(0 To 255) As Long
        For i = 0 To 255
            j = GetByte
            Seek #1, Seek(1) + 255
            k = GetByte
            Seek #1, Seek(1) + 255
            l = GetByte
            Seek #1, Seek(1) - 512
            Palette(i) = RGB(j, k, l)
        Next i
        Seek #1, Seek(1) + 512
    End If
    
    If Bpp = 8 Then
        ReDim Scanline(0 To FWidth - 1) As Byte
        For dy = 0 To FHeight - 1
            Get #1, , Scanline
            For dx = 0 To FWidth - odd
                j = Scanline(dx)
                FObject.PSet (dx, dy), Palette(j)
            Next dx
            If dy Mod 32 = 0 Then FObject.Refresh: DoEvents
        Next dy
        Erase Scanline
        Erase Palette
        Close #1
    ElseIf Bpp = 24 Then
        ReDim Scan(0 To FWidth * FHeight * 3 - 1) As Byte
        Get #1, , Scan
        Close #1
        For dy = 0 To FHeight - 1
            For dx = 0 To FWidth - 1
                i = Scan(3 * (dy * FWidth + dx))
                j = Scan(3 * (dy * FWidth + dx) + 1)
                k = Scan(3 * (dy * FWidth + dx) + 2)
                FObject.PSet (dx, dy), RGB(k, j, i)
            Next dx
            If dy Mod 32 = 0 Then FObject.Refresh: DoEvents
        Next dy
        Erase Scan
    ElseIf Bpp = 1 Then
        dx = 0: dy = 0
        Do Until EOF(1) Or dy >= FHeight
            k = GetByte
            For i = 7 To 0 Step -1
                If dx = FWidth And FWidth Mod 2 Then dx = 0: dy = dy + 1: Exit For
                If k And 2 ^ i Then FObject.PSet (dx, dy), &H0 Else FObject.PSet (dx, dy), &HFFFFFF
                dx = dx + 1
                If dx = FWidth Then
                    If dy Mod 16 = 0 Then FObject.Refresh: DoEvents
                    dx = 0: dy = dy + 1
                    Exit For
                End If
            Next i
        Loop
        Close #1
    End If
    Exit Sub
    
ErrorTrap0:
    Close #1
    MsgBox "There was an error reading the file:" + vbCrLf + Error$, vbCritical, "Error"
End Sub

Function GetByte() As Integer
    Dim a As Byte
    Get #1, , a
    GetByte = a
End Function

Function GetDword() As Long
    Dim a As Byte
    Dim d As Long
    Get #1, , a: d = CLng(a) * 16777216
    Get #1, , a: d = d + CLng(a) * 65536
    Get #1, , a: d = d + CLng(a) * 256
    Get #1, , a: d = d + CLng(a)
    GetDword = d
End Function

